/**
 * Blockly Apps 
 *
 * Copyright 2012 Google Inc.
 * https://blockly.googlecode.com/
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * @fileoverview JavaScript for Blockly's Maze application.
 * @author fraser@google.com (Neil Fraser)
 */
 
/**
 * modificato da ivana@ivana.it (Ivana Sacchi)
 */
 
var StringaRisposta='vale ...';
 
    
 var NumeroRisultato= null;  
 
   var Larghezza=0;
   var Altezza=0;
   
   
function init() {
    CaricaToolbox();
  	window.setInterval("Calcola()", 500);
     Blockly.mainWorkspace.clear();
 	var defaultXml ='<xml>'
 	  defaultXml += '<block movable="false" deletable="false" type="StampaRisultato" x="30" y="500">';
	   defaultXml += '<value name="VALUE"><block movable="false" deletable="false" type="OttieniVariabile"></block></value>';
	   defaultXml += '<value name="RISULTATO"><block movable="false" deletable="false" type="Risultato"></block></value>';
	  defaultXml += ' </block> ';
 	  defaultXml += '</xml>';
	  BlocklyApps.loadBlocks(defaultXml);
      window.addEventListener('resize', resizeCanvas, false);
   	  resizeCanvas();
   };
 
  function resizeCanvas() {
 	 var LarghezzaTmp=window.innerWidth;
	 var AltezzaTmp=window.innerHeight;
 	 if ((Math.abs(Larghezza- window.innerWidth)==0)&&(Math.abs(Altezza- window.innerHeight)==0))return;
	 Larghezza= window.innerWidth;
	 Altezza=window.innerHeight;
 	 var ContenitoreSvg = document.getElementById('ContenitoreBlocklyGrande');
	 ContenitoreSvg.style.width =(Larghezza -10)  + 'px';
	 ContenitoreSvg.style.height =((Altezza/10)*8)  + 'px';
  } 
 

 function Calcola(){
	   AB=0;
	   CD =0;
	   AC =0;
 	   BD =0;
 	   AD =0;
 	   BC =0;
 	   CH =0;
 	   HD =0;
	   perimetro=0;
	   area=0;
	   var code1 = Blockly.JavaScript.workspaceToCode();
       try {
		eval(code1);
		} catch (e) {
		}
	 	 
      var rootBlock = null;
	  var blocks = Blockly.mainWorkspace.getTopBlocks(false);
	  for (var i = 0, block; block = blocks[i]; i++) {
		if (block.type == 'StampaRisultato') {
		  rootBlock = block;
		}
	  }
	  var NumTmp = NaN;
	  Blockly.JavaScript.init();
	  var code = Blockly.JavaScript.blockToCode(rootBlock);
	  try {
	 		NumTmp = eval(code);
 	  } catch (e) {}
 	   NumeroRisultato=NumTmp;
 	   AggiornaBlocchi(Blockly.mainWorkspace.getAllBlocks());
 	 }
 
 function AggiornaBlocchi(blocks) {
    for (var i = 0, block; block = blocks[i]; i++) {
      	block.customUpdate && block.customUpdate();
    }
 } 

  
   
function CaricaToolbox(){
	var toolbox = '<xml>';
      				  toolbox += ' <block type="math_arithmetic"></block>';
   		     		  toolbox += ' <block type="math_number"></block>';
  	 	 	  		  toolbox += ' <block type="ImpostaVariabile"></block>';
	 				  toolbox += ' <block type="OttieniVariabile"></block>';
  	 				  toolbox += ' <block type="RadiceQuadrata"></block>';
	 	 	  		  toolbox += ' <block type="variables_set"></block>';
	 				  toolbox += ' <block type="variables_get"></block>';
    toolbox += '</xml>';
		 Blockly.inject(document.getElementById('ContenitoreBlocklyGrande'),{path: '../../../', toolbox: toolbox, scrollbars:true, trashcan: true  });		
     Blockly.JavaScript.INFINITE_LOOP_TRAP = '  BlocklyApps.checkTimeout(%1);\n';
	
 };
 
 
   